unsigned long int XRANDrand=0xA43C58DF;
unsigned long int XRANDranb=0xE629FDC4;
unsigned long int XRANDranc=0x18A7FC21;

void XRANDswap(unsigned long int *a,unsigned long int *b){
 unsigned long int c=*a;
 *a=*b;
 *b=c;
}

int FNxrand(int in){
 XRANDswap(&XRANDrand,&XRANDranb);

 XRANDrand=(XRANDrand<<15) | ((XRANDrand>>16)&0b00000000000000001111111111111111);
 XRANDrand=(~XRANDrand)<<1 | ((~XRANDrand)>>31 & 1);
 XRANDrand=XRANDrand ^ ((XRANDranb>>3)&0b00011111111111111111111111111111);
 XRANDrand=(XRANDrand<<8) | ((XRANDrand>>23)&0b00000000000000000000000111111111);
 XRANDranc=(XRANDranc<<1) | (XRANDrand&1);
 XRANDrand=XRANDrand ^ (XRANDranc & 256);

 if( in == 0) return XRANDrand;
 return (XRANDrand & 0b01111111111111111111111111111111) % in;
}


unsigned char FNxrand_byte(void){
 XRANDswap(&XRANDrand,&XRANDranb);

 XRANDrand=(XRANDrand<<15) | ((XRANDrand>>16)&0b00000000000000001111111111111111);
 XRANDrand=(~XRANDrand)<<1 | ((~XRANDrand)>>31 & 1);
 XRANDrand=XRANDrand ^ ((XRANDranb>>3)&0b00011111111111111111111111111111);
 XRANDrand=(XRANDrand<<8) | ((XRANDrand>>23)&0b00000000000000000000000111111111);
 XRANDranc=(XRANDranc<<1) | (XRANDrand&1);
 XRANDrand=XRANDrand ^ (XRANDranc & 256);

 return (XRANDrand & 255);
}